// gameracer.h
//
//////////////////////////////////////////////////////////////////////

#ifndef GAMERACER_H
#define GAMERACER_H

#include "game.h"
#include "critterarmed.h"
#include "critterwall.h"
//#include "critterblock.h"

class cGameRacer : public cGame
{
DECLARE_SERIAL(cGameRacer);
public:
	static Real WALLTHICKNESS;
	static Real MAXPLAYERSPEED;
	static Real PLAYERRADIUS;
	static Real WALLPRISMDZ;
	static Real RACERBACKGROUNDOFFSET;
	static Real RACERPLAYERBOUNCINESS;
public:
	cGameRacer();
	virtual void seedCritters();
	virtual void initializeView(CPopView *pview);
	virtual void initializeViewpoint(cCritterViewer *pviewer);
	virtual void fixSkyBox();
	virtual void drawBackground(cGraphics *pgraphics, int drawflags);
};

class cCritterRacerCar : public cCritterArmedRobot
{
DECLARE_SERIAL(cCritterRacerCar);
public:
	cCritterRacerCar(cGame *pownergame = NULL);
	virtual void update(CPopView *pactiveview, Real dt);
	virtual void animate(Real dt);
};

class cCritterRacerPlayer : public cCritterArmedPlayer
{
DECLARE_SERIAL(cCritterRacerPlayer);
public:
	cCritterRacerPlayer(cGame *pownergame = NULL);
	virtual void update(CPopView *pactiveview, Real dt);
	virtual void animate(Real dt);
};

class cCritterRacerPlayerBullet : public cCritterBullet
{
DECLARE_SERIAL(cCritterRacerPlayerBullet);
public:
	cCritterRacerPlayerBullet();
//overloads
	virtual BOOL isTarget(cCritter *pcritter);
	virtual void initialize(cCritterArmed *pshooter);
};

class cCritterCarBullet : public cCritterBullet
{
DECLARE_SERIAL(cCritterCarBullet);
public:
	cCritterCarBullet();
//overloads
	virtual BOOL isTarget(cCritter *pcritter);
	virtual void initialize(cCritterArmed *pshooter);
};

class cCritterRacerWall : public cCritterWall
{
DECLARE_SERIAL(cCritterRacerWall);
public:
	cCritterRacerWall(const cVector &enda = cVector(-0.5, 0.0),
		const cVector &endb = cVector(0.5, 0.0), 
		Real thickness = cGameRacer::WALLTHICKNESS, 
		Real height = cGameRacer::WALLPRISMDZ, 
		cGame *pownergame= NULL);
	cCritterRacerWall(const cVector &enda, const cVector &endb, cGame *pownergame= NULL);
};

#endif //GAMERACER_H