#ifndef GAMESPACEWARSUN
#define GAMESPACEWARSUN

#include "game.h"
#include "critterarmed.h"
#include "force.h"

//=== cGameSpacewarSun Helpers: cCritterArmedPlayerSpacewarSun, CritterAsteroid, cCritterSunUFO, CritterUFOSmart ===

class cCritterArmedPlayerSpacewarSun : public cCritterArmedPlayer //Our player.
{
DECLARE_SERIAL(cCritterArmedPlayerSpacewarSun);
private:
	static cVector STARTPOSITION;
public:
	cCritterArmedPlayerSpacewarSun(cGame *pownergame = NULL);
	void reset();
	virtual void update(CPopView *pactiveview, Real dt);
	virtual BOOL collide(cCritter *pcritter);
};

class cCritterSun : public cCritter
{
DECLARE_SERIAL(cCritterSun);
public:
	cCritterSun(cGame *pownergame = NULL);
	virtual void update(CPopView *pactiveview, Real dt);
};

class cCritterSunAsteroid : public cCritter
{
DECLARE_SERIAL(cCritterSunAsteroid);
public:
	static int VALUE;
	static int HEALTH;
	static Real CHASEACCELERATION; //Rate you accelerate towards ptarget.
	static Real DARTACCELERATION; //Rate you accelerate away from an enemy bullet.
	static Real DARTSPEEDUP; //When fleeing a bullet your maxspeed is multiplied by this.
	static int OVERPOPULATIONCOUNT; /* If there's more cCritterSunAsteroid than this
		we don't let them split in two. */
public:
	cCritterSunAsteroid(cGame *pownergame = NULL); /*I don't really need a default argument for the
		constructor in my code, but any DECLARE_SERIAL class requires a default constructor.  By
		giving pplayer a default NULL value, this acts also as a default no-argument constructor.*/
//overloads
	virtual int damage(int hitstrength);
};

class cCritterSunUFO : public cCritterArmedRobot
{
DECLARE_SERIAL(cCritterSunUFO);
public:
	static int VALUE;
	static int HEALTH;
	static Real CHASEACCELERATION; //Rate you accelerate towards ptarget.
	static Real DARTACCELERATIONBULLET; //Rate you accelerate away from an enemy bullet.
	static Real DARTSPEEDUPBULLET; //When fleeing a bullet your maxspeed is multiplied by this.
	static Real DARTACCELERATIONCRITTER; //Rate you accelerate away from other critters.
	static Real DARTSPEEDUPCRITTER; //When fleeing a critter your maxspeed is multiplied by this.
	static Real WAITSHOOT;
public:
	cCritterSunUFO(cGame *pownergame = NULL);
//overloads
	virtual int damage(int hitstrength);
	virtual void update(CPopView *pview, Real dt); 
		//overload to keep turning wrap flag off.
};

class cCritterSunUFOSmart : public cCritterSunUFO
{
DECLARE_SERIAL(cCritterSunUFOSmart);
public:
	static int HEALTH;
public:
	cCritterSunUFOSmart(cGame *pownergame = NULL);
};

class cCritterPlayerBulletSun : public cCritterBullet
{
DECLARE_SERIAL(cCritterPlayerBulletSun);
public:
	cCritterPlayerBulletSun();
	virtual void initialize(cCritterArmed *pshooter);
};

//======================= cGameSpacewarSun ================


class cGameSpacewarSun : public cGame
{
DECLARE_SERIAL(cGameSpacewarSun);
public:
	//See comments where these statics are implemented in gamespacewarsun.cpp
	static Real SUNWORLDWIDTH;
	static Real SUNWORLDHEIGHT;
	static Real CRITTERMINRADIUS;
	static Real CRITTERMAXRADIUS;
	static Real CRITTERMAXSPEED; //Starting max speed
	static Real CRITTERMAXSPEEDLIMIT; //Absolute maximum speed
	static Real PLAYERMAXSPEED;
	static Real SPEEDMULTIPLIER; 
	static Real ENEMYBULLETSPEED;
	static Real BULLETRADIUS;
	static Real ENEMYWAITSHOOT;
	static int PLAYERHEALTH;
	static int ENEMYBULLETVALUE;
	static int ENEMYMISSILEVALUE;
	static int SCORELEVEL;
	static int LEVELREWARD;
	static int UFOATTACKSCORE;
	static Real SMARTUFOPROBABILITY;
	static Real SUNGRAVITY;
	static Real SUNRADIUS;
	static Real SUNDENSITY;
	static Real BULLETDENSITY;
	static Real PLAYERDENSITY;
	static Real LISTENERACCELERATION;
	static Real SUNBULLETSEEK;

	int _lastinvasionscore; 
private:
	CArray<cCritterSun *, cCritterSun *> _psun;
public:
	cGameSpacewarSun();
	cCritterSun* psun(int i=0){return _psun[i];}
	int suncount(){return _psun.GetSize();}
 	virtual void Serialize(CArchive& ar); //Overload for _lastinvasionscore
	virtual void reset();
	virtual void adjustGameParameters();
	virtual CString statusMessage();
	virtual void initializeView(CPopView *pview);
	virtual void initializeViewpoint(cCritterViewer *pviewer);
	virtual void seedCritters();
 	virtual void setAutoplay(int autoplay); /* Overload so as to make sure the
		player is using cListenerSpaceship. */
};

#endif //GAMESPACEWARSUN