 /* gamespacewarsun3d.cpp: implementation of the cGameSpacewarSun3D class.
Initially, this file was exactly the same as gamespacewarsun.cpp, with
THREEDSUNWORLD commented in.  Over time, the two files are likely to diverge.
 */
  //////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "gamespacewarsun3d.h"
#include "critterarmed.h"
#include "listener.h"
#include "spriteicon.h"
#include "pop.h" //for playSound
#include "popview.h"
#include "force.h"
#include "spritepolygon.h"
#include "graphicsmfc.h"
#include "graphicsopengl.h"
#include "critterviewer.h"
#include "sprite3d.h"

//#define DEBUGSPACEWARSUN
	/* If I comment in DEBUGSPACEWARSUN, I start out with only a few other critters, and with
		my player shield on. */
//#define TESTINGALLCONTROLS
	/* If I comment in TESTINGALLCONTROLS, I allow shapes buttons and all the cursor tools
		 than I really need. */  
//#define SHOWBULLETCOUNT
	/*If you're interested in seeing the bullet count in the status bar
		comment in SHOWBULLETCOUNT.*/
//#define TWOSUN3D
	/* If TWOSUN3D we put in two suns instead of one. */
#define SLOWRUNTIME
	/* If SLOWRUNTIME, then I decrease the cPopApp _runtime field to make the
	game run slower. I'm having some problems with control response right now,
	though, so don't want to use this. */
	
IMPLEMENT_SERIAL(cGameSpacewarSun3D, cGame, 0);
IMPLEMENT_SERIAL(cCritterSun3D, cCritter, 0);
IMPLEMENT_SERIAL(cCritterSun3DAsteroid, cCritter, 0);
IMPLEMENT_SERIAL(cCritterSun3DUFO, cCritterArmedRobot, 0);
IMPLEMENT_SERIAL(cCritterSun3DUFOSmart, cCritterSun3DUFO, 0);
IMPLEMENT_SERIAL(cCritterArmedPlayerSpacewarSun3D, cCritterArmedPlayer, 0);
IMPLEMENT_SERIAL(cCritterPlayerBulletSun3D, cCritterBullet, 0);

  //==============================cGameSpacewarSun3D
 	//Size statics.--------------------------------------------------
Real cGameSpacewarSun3D::SUNWORLDWIDTH = 160.0; 
Real cGameSpacewarSun3D::SUNWORLDHEIGHT = 120.0; 
Real cGameSpacewarSun3D::CRITTERMINRADIUS = 0.75; //Keep them at a fixed size.
Real cGameSpacewarSun3D::CRITTERMAXRADIUS = 0.75; 
Real cGameSpacewarSun3D::BULLETRADIUS = 0.2;
 	//Speed statics.---------------------------------------------------
Real cGameSpacewarSun3D::CRITTERMAXSPEED = 200.0; /* We need quite high
	rates of speed, otherwise the gravitational orbits don't work; you
	need to be able to WHIP FAST around the sun at the close approach.*/
Real cGameSpacewarSun3D::SPEEDMULTIPLIER = 1.1; 
Real cGameSpacewarSun3D::CRITTERMAXSPEEDLIMIT = 350.0;/* The critters' max speed
	increases with each wave, and this bounds how fast they can get. */
Real cGameSpacewarSun3D::PLAYERMAXSPEED = 50.0;
//Sun statics------------------------------------
/* We are putting in a gravity force from each critter towards the sun of size
 SUNGRAVITY * SUNRADIUS^3 * SUNDENSITY * critterradius^3 * CRITTERDENSITY /
	distancetosun^2. */
Real cGameSpacewarSun3D::SUNGRAVITY = 10000.0;
Real cGameSpacewarSun3D::SUNRADIUS = 1.75;
	//Default critter density is 1.0.
Real cGameSpacewarSun3D::SUNDENSITY = 1.0;
Real cGameSpacewarSun3D::BULLETDENSITY = 0.01;
Real cGameSpacewarSun3D::PLAYERDENSITY = 0.01;
Real cGameSpacewarSun3D::LISTENERACCELERATION = 5000.0; /* Controls
	the power of the spaceship motor.  Nees to be huge to get
	away from the sun.  Default was 10. */
cVector cCritterArmedPlayerSpacewarSun3D::STARTPOSITION =
	cVector(0.85*0.5*cGameSpacewarSun3D::SUNWORLDWIDTH, 0, 0); /* This
		will be a position 85% of the way from the origin to the 
		right edge of the world, which lies at half the WORLDSIZE. */
Real cGameSpacewarSun3D::SUNBULLETSEEK = 500.0;
Real cCritterSun3DAsteroid::CHASEACCELERATION = 0.2; /* 1.0 How strongly to head towards the player.
	If you make this too strong, it overrides the darting away from the bullet. */
Real cCritterSun3DAsteroid::DARTACCELERATION = 4.0; //How strongly to accelerate away from bullets. was 10.0
Real cCritterSun3DAsteroid::DARTSPEEDUP = 2.0; // How much to speed up when fleeing bullets. was 2.0
 
Real cCritterSun3DUFO::CHASEACCELERATION = 1.0; //How strongly to head towards the player. Was 2.0
Real cCritterSun3DUFO::DARTACCELERATIONCRITTER = 1.0; //How strongly to accelerate away from other critters.
Real cCritterSun3DUFO::DARTSPEEDUPCRITTER = 1.0; /* How much to speed up when fleeing critters. I make
 	this one since I already have a speedup factor from bullets. */
Real cCritterSun3DUFO::DARTACCELERATIONBULLET = 10.0; //How strongly to accelerate away from bullets. Was 20.0
Real cCritterSun3DUFO::DARTSPEEDUPBULLET = 2.0; // How much to speed up when fleeing bullets. Was 4.0
 	//Score statics ---------------------------------------------
 int cGameSpacewarSun3D::ENEMYBULLETVALUE = 4;
 int cGameSpacewarSun3D::ENEMYMISSILEVALUE = 8;
 int cCritterSun3DAsteroid::VALUE = 4;
 int cCritterSun3DUFO::VALUE = 6;
 int cGameSpacewarSun3D::SCORELEVEL = 100;
 int cGameSpacewarSun3D::UFOATTACKSCORE = 40; /*  Points needed to provoke a UFO attack, fun if this
 		is low and they come fast and furious. */
 	// Health statics ----------------------------------------------
 int cGameSpacewarSun3D::LEVELREWARD = 1; //How much extra health the player gets when rewarded.
 int cCritterSun3DUFO::HEALTH = 2; 
 int cCritterSun3DUFOSmart::HEALTH = 1; 
 int cCritterSun3DAsteroid::HEALTH = 2; 
 int cGameSpacewarSun3D::PLAYERHEALTH = 10;
 	//Other statics --------------------------------------------------
 Real cCritterSun3DUFO::WAITSHOOT = 1.5; //0.1 for steady fire

 Real cGameSpacewarSun3D::SMARTUFOPROBABILITY = 0.5;
		/* Probability of a UFO using smart missiles
  		instead of bullets.  Should be between 0.0 and 1.0. */ 
 int cCritterSun3DAsteroid::OVERPOPULATIONCOUNT = 10; /* Don't make more than this many asteroids. */
 
cGameSpacewarSun3D::cGameSpacewarSun3D():
	_lastinvasionscore(0)
{	
//Fix the menu selections you'll allow.
	_menuflags |= cGame::MENU_AUTOPLAY;
		 //Default _menuflags from cGame as hopper off autoplay off.  Turn on autoplay.
//_menuflags &= ~cGame::MENU_SHAPE;  // Turn off MENU_SHAPE
#ifdef TESTINGALLCONTROLS
	_menuflags |= cGame::MENU_SHAPE;
#endif //TESTINGALLCONTROLS
//Fix your statics
 	cCritter::MINRADIUS = cGameSpacewarSun3D::CRITTERMINRADIUS;
  	cCritter::MAXRADIUS = cGameSpacewarSun3D::CRITTERMAXRADIUS;
  	cCritter::MAXSPEED = cGameSpacewarSun3D::CRITTERMAXSPEED;
  	cCritterBullet::BULLETRADIUS = cGameSpacewarSun3D::BULLETRADIUS;
 	cCritterBulletSilver::SCOREVALUE = cGameSpacewarSun3D::ENEMYBULLETVALUE;
  	cCritterBulletSilverMissile::SCOREVALUE = cGameSpacewarSun3D::ENEMYMISSILEVALUE;
	cCritterBullet::BULLETSPEED *= 1.1;
//Set the cursor tools.
  	_arrayHCURSOR.Add(((CPopApp*)::AfxGetApp())->_hCursorPlay); /*_arrayHCURSOR has
  		only the _hCursorArrow inherited from cGame.  Add a Shooting cursor. */
#ifdef TESTINGALLCONTROLS  //I don't normally want these, but if I want to try out all controls, put 'em in.
	_arrayHCURSOR.Add(((CPopApp*)::AfxGetApp())->_hCursorZap);
  	_arrayHCURSOR.Add(((CPopApp*)::AfxGetApp())->_hCursorReplicate);
  	_arrayHCURSOR.Add(((CPopApp*)::AfxGetApp())->_hCursorDragger);
  	_arrayHCURSOR.Add(((CPopApp*)::AfxGetApp())->_hCursorPin);
#endif //TESTINGALLCONTROLS
//Set your world shape with the _border and wrapflag
   		 //Use a square world.  Comment out for rectangle.
   	setBorder(cGameSpacewarSun3D::SUNWORLDWIDTH, cGameSpacewarSun3D::SUNWORLDHEIGHT,
		cGameSpacewarSun3D::SUNWORLDHEIGHT);
 	setWrapflag(cCritter::WRAP);
  		//cCritter::BOUNCE turns off wrap to make it easier to shoot things,
		//WRAP makes it a little more confusing.
	cRealBox3 skeleton = _border;
	setSkyBox(&skeleton);
	pskybox()->setSideInvisible(HIZ);
	pskybox()->setSideInvisible(HIY);
	pskybox()->setSideSolidColor(LOZ, cColorStyle::CN_GRAY);
	pskybox()->setSideSolidColor(LOY, cColorStyle::CN_BLACK);
	pskybox()->setSideSolidColor(LOX, cColorStyle::CN_DARKBLUE);
	pskybox()->setSideSolidColor(HIX, cColorStyle::CN_DARKGREEN);
//Make a player
   	setPlayer(new cCritterArmedPlayerSpacewarSun3D(this));
	_seedcount = 20;
#ifdef DEBUGSPACEWARSUN
	_seedcount = 1;
#endif //DEBUGSPACWAR
	//Set the default spritetype for asteroids
	_spritetype = cGame::ST_SPHERES ; //Used by cCritterSun3DAsteroid
	cCritterSun3D *psunnew = new cCritterSun3D(this);
	psunnew->moveTo(cVector(0.333 * _border.hix(), 0.0));
	_psun.Add(psunnew);
#ifdef TWOSUN3D
	psunnew = new cCritterSun3D(this);
	psunnew->moveTo(cVector(0.666 * _border.lox(), 
		0.666 * _border.loy(), 0.0));
	_psun.Add(psunnew);
#endif //TWOSUN3D
	for (int i=0; i<suncount(); i++)
		pplayer()->addForce(new cForceObjectGravity(psun(i),
				cGameSpacewarSun3D::SUNGRAVITY)); 
	pplayer()->reset(); //Moves it into position.
#ifdef SLOWRUNTIME
// The game runs too fast.  So I'll slow it down by changing _runspeed
	Real slowdown = 0.6;
	((CPopApp*)::AfxGetApp())->setRunspeed(slowdown); /* Looks and plays 
		better if you run it in slo motion. */
#endif //SLOWRUNTIME
 }
    
void cGameSpacewarSun3D::seedCritters()
  {
  /* Get rid of any asteroids and bullets, but if there are UFOs, leave them alone. */
  	_pbiota->purgeCritters(RUNTIME_CLASS(cCritterBullet));
  	_pbiota->purgeCritters(RUNTIME_CLASS(cCritterSun3DAsteroid));
  	for (int i=0; i < _seedcount; i++)  
  		new cCritterSun3DAsteroid(this); 
#ifdef DEBUGSPACEWARSUN
  	new cCritterSun3DUFOSmart(this); 
#endif // DEBUGSPACEWARSUN
  }

void cGameSpacewarSun3D::setAutoplay(int autoplay)
{
	cGame::setAutoplay(autoplay);
	if (autoplay)
		pplayer()->setListener(new cListenerSpaceship());
}

void cGameSpacewarSun3D::reset()
{
  	_pbiota->purgeCritters(RUNTIME_CLASS(cCritterSun3DUFO));
		 //In case there's any UFOs left
	cGame::reset(); //Calls pplayer()->reset() and seedCritters().
 	cCritter::MAXSPEED = cGameSpacewarSun3D::CRITTERMAXSPEED;
	_lastinvasionscore = 0;
 	pplayer()->moveTo(0.8*_border.hix()*cVector::XAXIS);
}

void cGameSpacewarSun3D::initializeView(CPopView *pview)
{
	cGame::initializeView(pview); //You MUST call the base class method here.
	pview->setGraphicsClass(RUNTIME_CLASS(cGraphicsOpenGL));  //Start in 3D
	pview->setUseBackground(CPopView::FULL_BACKGROUND);
	pview->setCursor(((CPopApp*)::AfxGetApp())->_hCursorPlay);
	pview->pviewpointcritter()->setListener(new cListenerViewerRide());
}
	

void cGameSpacewarSun3D::initializeViewpoint(cCritterViewer *pviewer)
{
	//Same code as base class, but put it here for tweaking.
		/* The two args to setViewpoint are (directiontoviewer, lookatpoint).
			Note that directiontoviewer points FROM the origin TOWARDS the viewer. */
	if (pviewer->is3D())
	{
		pviewer->setViewpoint(cVector3(0.0, 1.0, 1.0), _border.center());
			//Direction to viewer is up a bit, and back off less than that.
		if (pviewer->plistener()->GetRuntimeClass() == RUNTIME_CLASS(cListenerViewerRide))
		{
			pviewer->resetZoom();
			pviewer->zoom(0.5);
		}
		else //not riding the player
			pviewer->zoom(2.0);
	}
	else //2D case.
		pviewer->setViewpoint(cVector::ZAXIS, _border.center());
}

CString cGameSpacewarSun3D::statusMessage()
  {
  	CString cStrStatusBar = cGame::statusMessage();
#ifdef SHOWBULLETCOUNT 
 	CString cStrBulletCount;
  	cStrBulletCount.Format("Bullets: %d.", _pbiota->count(RUNTIME_CLASS(cCritterBullet)));
  	cStrStatusBar = cStrStatusBar + "  " + cStrBulletCount;
#endif //SHOWBULLETCOUNT
  	return cStrStatusBar;
  }
  
void cGameSpacewarSun3D::adjustGameParameters()
{
#ifndef DEBUGSPACEWARSUN //Turn this method off when debugging, so you can have no asteroids.
		// (1) End the game if the player is dead
	if (!health()  && !_gameover) //Player's been killed and game's not over.
	{
		_gameover = TRUE;
		pplayer()->addScore(_scorecorrection); // So user can reach _maxscore 
		playSound("Tada");
		return;
	}
		// (2) Reseed the screen if all the asteroids are gone (There may still be UFOs present)
	if (_pbiota->count(RUNTIME_CLASS(cCritterSun3DAsteroid)) == 0 ) 
	{ //If the crittercount - bulletcount = 1, then player's alone, and the enemies are all gone.
		cCritter::MAXSPEED *= SPEEDMULTIPLIER;//Speed the critters  up.
		if (cCritter::MAXSPEED > cGameSpacewarSun3D::CRITTERMAXSPEEDLIMIT)
			cCritter::MAXSPEED = cGameSpacewarSun3D::CRITTERMAXSPEEDLIMIT;
		seedCritters();
	}
		// (3) Attack with a UFO if enough score has elapsed and there aren't any other UFOs
	if (score() - _lastinvasionscore > cGameSpacewarSun3D::UFOATTACKSCORE &&							//More score brings more UFOs
		!_pbiota->count(RUNTIME_CLASS(cCritterSun3DUFO)))
					//Don't start a new UFO till old ones are gone.
	{
		playSound("TaDa"); //Warning single.
		if (cRandomizer::pinstance()->randomBOOL(cGameSpacewarSun3D::SMARTUFOPROBABILITY))
			 new cCritterSun3DUFOSmart(this); 
		else
			 new cCritterSun3DUFO(this);
		_lastinvasionscore = score();
	}
#endif // DEBUGSPACEWARSUN
}
 
 void cGameSpacewarSun3D::Serialize(CArchive& ar)
 {
 	cGame::Serialize(ar);
  	if (ar.IsStoring()) // Save 
 		ar << _lastinvasionscore;
  	else //Load 
 		ar >> _lastinvasionscore;
}

//====================cCritterArmedPlayerSpacewarSun3D
cCritterArmedPlayerSpacewarSun3D::cCritterArmedPlayerSpacewarSun3D(cGame *pownergame):
cCritterArmedPlayer(pownergame)
{
  	setSensitive(TRUE);
  	setHealth(cGameSpacewarSun3D::PLAYERHEALTH);
  	setNewlevelreward(cGameSpacewarSun3D::LEVELREWARD);
  	setNewlevelscorestep(cGameSpacewarSun3D::SCORELEVEL);
 	setBulletClass(RUNTIME_CLASS(cCritterPlayerBulletSun3D));
  //	setListener(new cListenerSpaceship());
  	setListener(new cListenerScooter());
	setListenerAcceleration(cGameSpacewarSun3D::LISTENERACCELERATION);
  	psprite()->setLineColor(cColorStyle::CN_WHITE); //White edges as we use black background.
	setMaxspeed(cGameSpacewarSun3D::PLAYERMAXSPEED);
	setDensity(cGameSpacewarSun3D::PLAYERDENSITY);
	setRadius(1.5);
#ifdef DEBUGSPACEWARSUN
	setShield(TRUE); //invulnerable for debugging
#endif //DEBUGSPACEWARSUN
//	addForce(new cForceDrag(0.01)); //Makes it less hyperactive
}

void cCritterArmedPlayerSpacewarSun3D::reset()
{
	cCritterArmedPlayer::reset();
  	setHealth(cGameSpacewarSun3D::PLAYERHEALTH);
	moveTo(STARTPOSITION, FALSE);
		//FALSE in second arg means do a hyperjump
	setVelocity(0.25*maxspeed()*cVector::YAXIS);
	cGameSpacewarSun3D *pgamesun = (cGameSpacewarSun3D *)pgame();
		//I have to cast pgame so I can use the psun() accessor.
	lookAt(pgamesun->psun(0)->position());
//	setAttitudeTangent(cVector::YAXIS);
}

void cCritterArmedPlayerSpacewarSun3D::update(CPopView *pactiveview, Real dt)
{
	setWrapflag(cCritter::BOUNCE); //Don't ever let him wrap.
	cCritterArmedPlayer::update(pactiveview, dt); 
	/* I don't actually need to do anything extra in here, I'm letting my
	collide handle the reset after hitting the sun */
}

BOOL cCritterArmedPlayerSpacewarSun3D::collide(cCritter *pother)
{
	BOOL collideflag = cCritterArmedPlayer::collide(pother);
	if (collideflag)
	{
		cGameSpacewarSun3D *pgamesun = (cGameSpacewarSun3D *)pgame();
		//I have to cast pgame so I can use the psun() accessor.
		BOOL hittingsun = FALSE;
		for (int i=0; i<pgamesun->suncount(); i++)
 			if(pgamesun->psun(i) == pother)
			{
				hittingsun = TRUE;
				break;
			}
		if (hittingsun)
		{
			damage(1);
			int oldhealth = health();
			if (oldhealth)
			{
				reset();
				setHealth(oldhealth); /* I have to do 
					this because reset restores health
					as well as moving to start position. */
			}
		}
	}
	return collideflag;
}
//====================cCritterPlayerBulletSun3D==================
cCritterPlayerBulletSun3D::cCritterPlayerBulletSun3D()
{
	_dieatedges = TRUE; //Controls if you want the bullet to wrap around
	setRadius(2.0*cCritter::BULLETRADIUS);
	setDensity(cGameSpacewarSun3D::BULLETDENSITY);
	setMaxspeed(cGameSpacewarSun3D::CRITTERMAXSPEED);
	setSpeed(cGameSpacewarSun3D::PLAYERMAXSPEED);
}

void cCritterPlayerBulletSun3D::initialize(cCritterArmed *pshooter)
{
	cCritterBullet::initialize(pshooter);
		/* Initialize points the bullet in the pshooter aim direction, sets it down
		at the tip of the gun, copies the wrap flag from shooter, copies the
		physics forces from pshooter, and leaves the speed to whatever it was
		set in the bullet constructor. In the case where the shooter is the player,
		we may possibly have increased the bullet speed if the player is moving
		in the direction it shoots. */
//	clearForcearray(); 
		/* Could clearForcearray to remove the "physics" forces
		like sun gravity and maybe drag which you got form player. */
		/* This code is called from within the cCritterArmed::shoot method,
		and the bullet isn't yet part of the game, so we can't use pgame(),
		instead use pshooter->pgame()*/
	cCritter* paimasteroid = pshooter->pgame()->pbiota()->pickClosestAhead(
		cLine(position(), tangent()), this, PI/4.0,
		RUNTIME_CLASS(cCritterSun3DAsteroid), TRUE);
	/* Find asteroid critter closest to your aiming line but ahead of you ("this").  Only
	consider critters within a PI/4.0 cone aroudn the aiming line, and only
	consider critters of the class cCritter or (TRUE) its subclasses.  */
	cCritter* paimenemy = pshooter->pgame()->pbiota()->pickClosestAhead(
		cLine(position(), tangent()), this, PI/4.0,
		RUNTIME_CLASS(cCritterSun3DUFO), TRUE);
	/* Find enemy as well. */
	cCritter* paimtarget; /* Prefer shooting enemy. */
	if (paimenemy)
		paimtarget = paimenemy;
	else
		paimtarget = paimasteroid;
	if (paimtarget) //No point seeking a nonexistent target.
      	addForce(new cForceObjectSeek(paimtarget,
			cGameSpacewarSun3D::SUNBULLETSEEK));
}

  //==================== cCritterSun3D ====================
 
cCritterSun3D::cCritterSun3D(cGame *pownergame):cCritter(pownergame)
{
	setShield(TRUE);
	cSprite *psphere = new cSpriteSphere();
	psphere->setFillColor(cColorStyle::CN_YELLOW);
	setSprite(psphere); 
	moveTo(cVector::ZEROVECTOR);
	setFixedflag(TRUE);
	setSpeed(0.0);
	setDensity(cGameSpacewarSun3D::SUNDENSITY);
//	setAbsorberflag(TRUE);
	setRadius(cGameSpacewarSun3D::SUNRADIUS);
}

void cCritterSun3D::update(CPopView *pactiveview, Real dt)
{
	cCritter *pc;
	for (int i=0; i<pgame()->pbiota()->count(); i++)
	{
		pc = pgame()->pbiota()->GetAt(i);
		if (touch(pc) && pc != this && pc != pplayer())
		{
			pc->die();
		//	playSound("Tock"); //don't do this, it slows game down.
		}
	}
}
 
//==================== cCritterSun3DAsteroid ====================
 
 cCritterSun3DAsteroid::cCritterSun3DAsteroid(cGame *pownergame):cCritter(pownergame)
 {
  	setHealth(cCritterSun3DAsteroid::HEALTH); 
  		/* One more than the number of times it splits.  Splitting is also capped by the
  			cCritterSun3DAsteroid::OVERPOPULATIONCOUNT, which might be about 10; if there are
  			more than this many asteroids they don't split when you shoot them. */
 	setValue(cCritterSun3DAsteroid::VALUE);
	if (pownergame) //Just to be safe.
		setSprite(pgame()->randomSprite(pownergame->spritetype())); 
		/* Let the game	set the current default sprite. */
  	randomize(cCritter::MF_VELOCITY | cSprite::MF_RADIUS);
	setSpeed(20.0);
  	psprite()->setLineColor(cColorStyle::CN_WHITE); //White edges as we use black background.
 	addForce(new cForceClassEvade(
		cCritterSun3DAsteroid::DARTACCELERATION,
 		cCritterSun3DAsteroid::DARTSPEEDUP,
		RUNTIME_CLASS(cCritterBullet), FALSE)); 
 			/*	cForceClassEvade is an allpurpose evading force used for evading any class I like.
 				The third argument says which class to evade, and the fourth argument says whether 
 				to evade objects that are of classes that are child classes of the class to evade. 
 				Putting FALSE means I don't evade cCritterBulletSilver and 
 				CritterBulletSilverMissile (as that would be a waste of energy since these 
 				can't hurt me.) 
 			*/
   	moveToMoveboxEdge();
	setTangent(position().defaultNormal());
	cGameSpacewarSun3D *pgamesun = (cGameSpacewarSun3D *)pownergame;
	if (pgamesun)
	{ //Then we know we added this to a game so pplayer() is valid
 		addForce(new cForceObjectSeek(pplayer(), cCritterSun3DAsteroid::CHASEACCELERATION));
 			/* Force for accerlating towards a critter. */
		for (int i=0; i<pgamesun->suncount(); i++)
 			addForce(new cForceObjectGravity(pgamesun->psun(i),
				cGameSpacewarSun3D::SUNGRAVITY)); //Try some weak gravity.
	}
}
 
 int cCritterSun3DAsteroid::damage(int hitstrength)
 {
 	if ( _shieldflag || recentlyDamaged())
 		return 0; /* Bail out right here if you were just damaged or if you were just replicated
 			from a just-damaged guy. Otherwise a newly replicated critter hit by one of a fusillade
 			of bullets that split its parent will get to split as well. */
 	int deathreward = cCritter::damage(hitstrength); /* This is _value (typically nonzero) you get
 		for killing off the critter. */
 	playSound("Ding"); //Signal the hit.
 	if (_health) // If not dead yet, let's replicate unless there's too many cCritterSun3DAsteroid.
 	{
 		setRadius(radius()/sqrt(2.0));
 		mutate(cCritter::MF_NUDGE); //Crude way to show a hit.
 		if (pownerbiota()->count(RUNTIME_CLASS(cCritterSun3DAsteroid)) < 
 				cCritterSun3DAsteroid::OVERPOPULATIONCOUNT)
 			replicate(); //Ask cBiota to make a copy in next updateServiceRequests call.
 	}
 	return deathreward;
 }

 //==================== cCritterSun3DUFO ====================
 
 cCritterSun3DUFO::cCritterSun3DUFO(cGame *pownergame):cCritterArmedRobot(pownergame)
 {
 	setBulletClass(RUNTIME_CLASS(cCritterBulletSilver));
 	setWaitShoot(cRandomizer::pinstance()->randomReal(0.8, 1.2)
 		* cCritterSun3DUFO::WAITSHOOT); /* Make this slightly indeterminate so they don't all shoot in 
 			synch in case you make several. */
 	setHealth(cCritterSun3DUFO::HEALTH); 
  	setValue(cCritterSun3DUFO::VALUE);
	if (pgame())
		setSprite(pgame()->randomSprite(cGame::ST_BUBBLES));
  	psprite()->setLineColor(cColorStyle::CN_WHITE); /* White edges as we use black background.
 		Note that this color affect bullets you shoot as well as your own sprite. */
 	randomize(cCritter::MF_VELOCITY | cSprite::MF_RADIUS);
 		/* In order to make the UFO motions more chaotic and interesting, I'm going to give them 
 			three competing forces. */
	addForce(new cForceClassEvade(cCritterSun3DUFO::DARTACCELERATIONCRITTER,
 		cCritterSun3DUFO::DARTSPEEDUPCRITTER, RUNTIME_CLASS(cCritterSun3DAsteroid))); /* This says
			to weakly evade asteroids. Default fourth argument is FALSE, meaning only
			respond to the class you specify and not it's children.*/
 	addForce(new cForceEvadeBullet(cCritterSun3DUFO::DARTACCELERATIONBULLET, 
 		cCritterSun3DUFO::DARTSPEEDUPBULLET));/* Strongly evade bullets. This force is a child of 
			cForceClassEvade with default RUNTIME_CLASS(cCritterBullet) and FALSE in the thrid
			and fourth arg, so doesn't evade children of cCritterBullet. */
	setWrapflag(cCritter::BOUNCE); //Call out here as the add overrides this.
  	moveToMoveboxEdge();
 	setTangent(position().defaultNormal());
	cGameSpacewarSun3D *pgamesun = (cGameSpacewarSun3D *)pownergame;
	if (pgamesun)
	{ //Then we know we added this to a game so pplayer() is valid
		setTarget(pplayer());
			//Need target for the silver or guided bullets of cCritterArmedRobot
//		addForce(new cForceObjectSeek(pplayer(), cCritterSun3DUFO::CHASEACCELERATION));
			//Move towards the player.
		for (int i=0; i<pgamesun->suncount(); i++)
 			addForce(new cForceObjectGravity(pgamesun->psun(i),
				cGameSpacewarSun3D::SUNGRAVITY)); //Try some weak gravity.
 		makeServiceRequest("move_to_front");
	}
 }
 
void cCritterSun3DUFO::update(CPopView *pactiveview, Real dt)
{
	cCritterArmedRobot::update(pactiveview, dt); //Always call the base class update.
	setWrapflag(cCritter::BOUNCE); /* If I've split or if game has changed wrap, I 
		may have gotten my wrapflag set to cCritter::WRAP, so I always reset it here
		to be save. */
}

 //==================== cCritterSun3DUFOSmart ====================

 cCritterSun3DUFOSmart::cCritterSun3DUFOSmart(cGame *pownergame):
 cCritterSun3DUFO(pownergame)
 {
 	setBulletClass(RUNTIME_CLASS(cCritterBulletSilverMissile));
 	setHealth(cCritterSun3DUFOSmart::HEALTH); 
	if (pownergame) //Just to be safe.
		setSprite(pgame()->randomSprite(cGame::ST_MESHSKIN)); 
	setMaxspeed(2*cCritter::MAXSPEED); //Make these guys extra fast.
 }
 
 int cCritterSun3DUFO::damage(int hitstrength)
 {
 	if ( _shieldflag || recentlyDamaged())
 		return 0; /* Bail out right here if you were just damaged or if you were just replicated
 			from a just-damaged guy. Otherwise a newly replicated critter hit by one of a fusillade
 			of bullets that split its parent will get to split as well. */
 	int deathreward = cCritter::damage(hitstrength); /* This is _value (typically nonzero) you get
 		for killing off the critter. */
 	playSound("Pop"); //Signal the hit.
 	if (_health) //If not dead yet, let's replicate.
 	{
 		setRadius(radius()/sqrt(2.0));
 		mutate(cCritter::MF_NUDGE); //Crude way to show a hit.
 		replicate(); //Ask cBiota to make a copy in next updateServiceRequests call.
 	}
 	return deathreward;
 }

