#ifndef GAMESPACEWARSUN3D
#define GAMESPACEWARSUN3D

#include "game.h"
#include "critterarmed.h"
#include "force.h"

//=== cGameSpacewarSun3D Helpers: cCritterArmedPlayerSpacewarSun3D, CritterAsteroid, cCritterSun3DUFO, CritterUFOSmart ===

class cCritterArmedPlayerSpacewarSun3D : public cCritterArmedPlayer //Our player.
{
DECLARE_SERIAL(cCritterArmedPlayerSpacewarSun3D);
private:
	static cVector STARTPOSITION;
public:
	cCritterArmedPlayerSpacewarSun3D(cGame *pownergame = NULL);
	void reset();
	virtual void update(CPopView *pactiveview, Real dt);
	virtual BOOL collide(cCritter *pcritter);
};

class cCritterSun3D : public cCritter
{
DECLARE_SERIAL(cCritterSun3D);
public:
	cCritterSun3D(cGame *pownergame = NULL);
	virtual void update(CPopView *pactiveview, Real dt);
};

class cCritterSun3DAsteroid : public cCritter
{
DECLARE_SERIAL(cCritterSun3DAsteroid);
public:
	static int VALUE;
	static int HEALTH;
	static Real CHASEACCELERATION; //Rate you accelerate towards ptarget.
	static Real DARTACCELERATION; //Rate you accelerate away from an enemy bullet.
	static Real DARTSPEEDUP; //When fleeing a bullet your maxspeed is multiplied by this.
	static int OVERPOPULATIONCOUNT; /* If there's more cCritterSun3DAsteroid than this
		we don't let them split in two. */
public:
	cCritterSun3DAsteroid(cGame *pownergame = NULL); /*I don't really need a default argument for the
		constructor in my code, but any DECLARE_SERIAL class requires a default constructor.  By
		giving pplayer a default NULL value, this acts also as a default no-argument constructor.*/
//overloads
	virtual int damage(int hitstrength);
};

class cCritterSun3DUFO : public cCritterArmedRobot
{
DECLARE_SERIAL(cCritterSun3DUFO);
public:
	static int VALUE;
	static int HEALTH;
	static Real CHASEACCELERATION; //Rate you accelerate towards ptarget.
	static Real DARTACCELERATIONBULLET; //Rate you accelerate away from an enemy bullet.
	static Real DARTSPEEDUPBULLET; //When fleeing a bullet your maxspeed is multiplied by this.
	static Real DARTACCELERATIONCRITTER; //Rate you accelerate away from other critters.
	static Real DARTSPEEDUPCRITTER; //When fleeing a critter your maxspeed is multiplied by this.
	static Real WAITSHOOT;
public:
	cCritterSun3DUFO(cGame *pownergame = NULL);
//overloads
	virtual int damage(int hitstrength);
	virtual void update(CPopView *pview, Real dt); 
		//overload to keep turning wrap flag off.
};

class cCritterSun3DUFOSmart : public cCritterSun3DUFO
{
DECLARE_SERIAL(cCritterSun3DUFOSmart);
public:
	static int HEALTH;
public:
	cCritterSun3DUFOSmart(cGame *pownergame = NULL);
};

class cCritterPlayerBulletSun3D : public cCritterBullet
{
DECLARE_SERIAL(cCritterPlayerBulletSun3D);
public:
	cCritterPlayerBulletSun3D();
	virtual void initialize(cCritterArmed *pshooter);
};

//======================= cGameSpacewarSun3D ================


class cGameSpacewarSun3D : public cGame
{
DECLARE_SERIAL(cGameSpacewarSun3D);
public:
	//See comments where these statics are implemented in gamespacewarsun.cpp
	static Real SUNWORLDWIDTH;
	static Real SUNWORLDHEIGHT;
	static Real CRITTERMINRADIUS;
	static Real CRITTERMAXRADIUS;
	static Real CRITTERMAXSPEED; //Starting max speed
	static Real CRITTERMAXSPEEDLIMIT; //Absolute maximum speed
	static Real PLAYERMAXSPEED;
	static Real SPEEDMULTIPLIER; 
	static Real ENEMYBULLETSPEED;
	static Real BULLETRADIUS;
	static Real ENEMYWAITSHOOT;
	static int PLAYERHEALTH;
	static int ENEMYBULLETVALUE;
	static int ENEMYMISSILEVALUE;
	static int SCORELEVEL;
	static int LEVELREWARD;
	static int UFOATTACKSCORE;
	static Real SMARTUFOPROBABILITY;
	static Real SUNGRAVITY;
	static Real SUNRADIUS;
	static Real SUNDENSITY;
	static Real BULLETDENSITY;
	static Real PLAYERDENSITY;
	static Real LISTENERACCELERATION;
	static Real SUNBULLETSEEK;

	int _lastinvasionscore; 
private:
	CArray<cCritterSun3D *, cCritterSun3D *> _psun;
public:
	cGameSpacewarSun3D();
	cCritterSun3D* psun(int i=0){return _psun[i];}
	int suncount(){return _psun.GetSize();}
 	virtual void Serialize(CArchive& ar); //Overload for _lastinvasionscore
	virtual void reset();
	virtual void adjustGameParameters();
	virtual CString statusMessage();
	virtual void initializeView(CPopView *pview);
	virtual void initializeViewpoint(cCritterViewer *pviewer);
	virtual void seedCritters();
 	virtual void setAutoplay(int autoplay); /* Overload so as to make sure the
		player is using cListenerSpaceship. */
};

#endif //GAMESPACEWARSUN3D